## rock-master-20.01-ruby-orogen 1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(orogen)
FIND_PACKAGE(Ruby REQUIRED)

install(DIRECTORY bin/ DESTINATION bin 
  PATTERN "bin/*"
  PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
  GROUP_EXECUTE GROUP_READ)

STRING(REGEX REPLACE ".*lib(32|64)?/?" "lib/" RUBY_EXTENSIONS_INSTALL_DIR ${RUBY_ARCH_DIR})
install(DIRECTORY lib/ DESTINATION ${RUBY_EXTENSIONS_INSTALL_DIR})
