=== debian/changelog ===
rock-master-20.01-ruby-orogen (1.1-1~jessie) UNRELEASED; urgency=medium

  * Package automatically built using 'apaka'
  * repository: github:/orocos-toolchain/orogen.git
  * branch: refs/heads/master
  * commit: fe5b1aa50a6acbcf1f54469ebbad326ed954fe4d
  * tag: 

 -- Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>  Mon, 10 Feb 2020 00:00:01 +0100
