=== debian/control ===
Source: rock-master-20.01-ruby-orogen
Section: science
Priority: optional
Maintainer: Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>
Uploaders: Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>
Build-Depends: debhelper, gem2deb, rock-master-20.01-ruby-utilrb, rake, rubygems-integration, rock-master-20.01-rtt, rock-master-20.01-typelib, rock-master-20.01-rtt-typelib, rock-master-20.01-ruby-tools-metaruby, dh-autoreconf
Standards-Version: 4.1.3
Vcs-Git:
Vcs-Browser:
Homepage: http://rock-robotics.org
Testsuite: autopkgtest-pkg-ruby
XS-Ruby-Versions: all

Package: rock-master-20.01-ruby-orogen
Architecture: any
XB-Ruby-Versions: ${ruby:Versions}
Depends: rake, rubygems-integration, rock-master-20.01-rtt, rock-master-20.01-typelib, rock-master-20.01-rtt-typelib, rock-master-20.01-ruby-utilrb, rock-master-20.01-ruby-tools-metaruby
Description: Rock component specification and code generation
